diff --git a/drivers/input/keyboard/mtk-pmic-keys.c b/drivers/input/keyboard/mtk-pmic-keys.c
index d8285612265f..acd5aefac5f9 100644
--- a/drivers/input/keyboard/mtk-pmic-keys.c
+++ b/drivers/input/keyboard/mtk-pmic-keys.c
@@ -18,11 +18,9 @@
 #include <linux/platform_device.h>
 #include <linux/regmap.h>
 
-#define MTK_PMIC_RST_DU_MASK		0x3
-#define MTK_PMIC_RST_DU_SHIFT		8
-
 #define MTK_PMIC_MT6397_HOMEKEY_RST_EN	BIT(5)
 #define MTK_PMIC_MT6397_PWRKEY_RST_EN	BIT(6)
+#define MTK_PMIC_MT6397_RST_DU_MASK	GENMASK(9, 8)
 
 #define MTK_PMIC_PWRKEY_INDEX	0
 #define MTK_PMIC_HOMEKEY_INDEX	1
@@ -58,10 +56,12 @@ struct mtk_pmic_keys_regs {
  * struct mtk_pmic_regs - PMIC Keys registers
  * @keys_regs:           Specific key registers
  * @pmic_rst_reg:        PMIC Keys reset register
+ * @rst_lprst_mask:      Long-press reset timeout bitmask
  */
 struct mtk_pmic_regs {
 	const struct mtk_pmic_keys_regs keys_regs[MTK_PMIC_MAX_KEY_COUNT];
 	u32 pmic_rst_reg;
+	u32 rst_lprst_mask;
 };
 
 static const struct mtk_pmic_regs mt6397_regs = {
@@ -72,6 +72,7 @@ static const struct mtk_pmic_regs mt6397_regs = {
 		MTK_PMIC_KEYS_REGS(MT6397_OCSTATUS2,
 		0x10, MT6397_INT_RSV, 0x8, MTK_PMIC_MT6397_HOMEKEY_RST_EN),
 	.pmic_rst_reg = MT6397_TOP_RST_MISC,
+	.rst_lprst_mask = MTK_PMIC_MT6397_RST_DU_MASK,
 };
 
 static const struct mtk_pmic_regs mt6323_regs = {
@@ -82,6 +83,7 @@ static const struct mtk_pmic_regs mt6323_regs = {
 		MTK_PMIC_KEYS_REGS(MT6323_CHRSTATUS,
 		0x4, MT6323_INT_MISC_CON, 0x8, MTK_PMIC_MT6397_HOMEKEY_RST_EN),
 	.pmic_rst_reg = MT6323_TOP_RST_MISC,
+	.rst_lprst_mask = MTK_PMIC_MT6397_RST_DU_MASK,
 };
 
 static const struct mtk_pmic_regs mt6358_regs = {
@@ -94,6 +96,7 @@ static const struct mtk_pmic_regs mt6358_regs = {
 				   0x8, MT6358_PSC_TOP_INT_CON0, 0xa,
 				   MTK_PMIC_MT6397_HOMEKEY_RST_EN),
 	.pmic_rst_reg = MT6358_TOP_RST_MISC,
+	.rst_lprst_mask = MTK_PMIC_MT6397_RST_DU_MASK,
 };
 
 /**
@@ -135,24 +138,26 @@ enum mtk_pmic_keys_lp_mode {
 };
 
 static void mtk_pmic_keys_lp_reset_setup(struct mtk_pmic_keys *keys,
-		u32 pmic_rst_reg)
+					 const struct mtk_pmic_regs *regs)
 {
 	int ret;
+	struct regmap *rmap;
 	u32 long_press_mode, long_press_debounce;
 	const struct mtk_pmic_keys_regs *kregs_pwr;
 	const struct mtk_pmic_keys_regs *kregs_home;
 
 	kregs_pwr = keys->keys[MTK_PMIC_PWRKEY_INDEX].regs;
 	kregs_home = keys->keys[MTK_PMIC_HOMEKEY_INDEX].regs;
+	rmap = keys->regmap;
 
 	ret = of_property_read_u32(keys->dev->of_node,
 		"power-off-time-sec", &long_press_debounce);
 	if (ret)
 		long_press_debounce = 0;
 
-	regmap_update_bits(keys->regmap, pmic_rst_reg,
-			   MTK_PMIC_RST_DU_MASK << MTK_PMIC_RST_DU_SHIFT,
-			   long_press_debounce << MTK_PMIC_RST_DU_SHIFT);
+	regmap_update_bits(rmap, regs->pmic_rst_reg,
+			   regs->rst_lprst_mask,
+			   long_press_debounce << ffs(regs->rst_lprst_mask));
 
 	ret = of_property_read_u32(keys->dev->of_node,
 		"mediatek,long-press-mode", &long_press_mode);
@@ -161,16 +166,16 @@ static void mtk_pmic_keys_lp_reset_setup(struct mtk_pmic_keys *keys,
 
 	switch (long_press_mode) {
 	case LP_ONEKEY:
-		regmap_set_bits(keys->regmap, pmic_rst_reg, kregs_pwr->rst_en_mask);
-		regmap_clear_bits(keys->regmap, pmic_rst_reg, kregs_home->rst_en_mask);
+		regmap_set_bits(rmap, regs->pmic_rst_reg, kregs_pwr->rst_en_mask);
+		regmap_clear_bits(rmap, regs->pmic_rst_reg, kregs_home->rst_en_mask);
 		break;
 	case LP_TWOKEY:
-		regmap_set_bits(keys->regmap, pmic_rst_reg, kregs_pwr->rst_en_mask);
-		regmap_set_bits(keys->regmap, pmic_rst_reg, kregs_home->rst_en_mask);
+		regmap_set_bits(rmap, regs->pmic_rst_reg, kregs_pwr->rst_en_mask);
+		regmap_set_bits(rmap, regs->pmic_rst_reg, kregs_home->rst_en_mask);
 		break;
 	case LP_DISABLE:
-		regmap_clear_bits(keys->regmap, pmic_rst_reg, kregs_pwr->rst_en_mask);
-		regmap_clear_bits(keys->regmap, pmic_rst_reg, kregs_home->rst_en_mask);
+		regmap_clear_bits(rmap, regs->pmic_rst_reg, kregs_pwr->rst_en_mask);
+		regmap_clear_bits(rmap, regs->pmic_rst_reg, kregs_home->rst_en_mask);
 		break;
 	default:
 		break;
@@ -378,7 +383,7 @@ static int mtk_pmic_keys_probe(struct platform_device *pdev)
 		return error;
 	}
 
-	mtk_pmic_keys_lp_reset_setup(keys, mtk_pmic_regs->pmic_rst_reg);
+	mtk_pmic_keys_lp_reset_setup(keys, mtk_pmic_regs);
 
 	platform_set_drvdata(pdev, keys);
 